//---------------------------------------------------------------------------
// wscitecm.h
//---------------------------------------------------------------------------
#ifndef __WSCITECM_H
#define __WSCITECM_H

// ShellExtension GUID
DEFINE_GUID(CLSID_ShellExtension,
            0xc4acbd3e, 0x6114, 0x4618, 0x90, 0x4c, 0xb2, 0x6, 0xab, 0xa9, 0xde, 0xb0);

class CShellExtClassFactory : public IClassFactory {
    protected:
        ULONG m_cRef;

    public:
        CShellExtClassFactory();
        ~CShellExtClassFactory();

        STDMETHODIMP QueryInterface(REFIID, LPVOID FAR *);
        STDMETHODIMP_(ULONG) AddRef();
        STDMETHODIMP_(ULONG) Release();
        STDMETHODIMP CreateInstance(LPUNKNOWN, REFIID, LPVOID FAR *);
        STDMETHODIMP LockServer(BOOL);
};
typedef CShellExtClassFactory *LPCSHELLEXTCLASSFACTORY;

class CShellExt : public IContextMenu, IShellExtInit {
    protected:
        ULONG m_cRef;
        UINT m_cbFiles;
        STGMEDIUM m_stgMedium;
        LPDATAOBJECT m_pDataObj;
        HBITMAP m_hIconBmp;
        LPMALLOC m_pAlloc;
        TCHAR m_szDllDir [MAX_PATH];

        STDMETHODIMP InvokeRealCommand(HWND hParent, LPCTSTR pszWorkingDir, LPCTSTR pszCmd, LPCTSTR pszParam, int iShowCmd);

    public:
        CShellExt();
        ~CShellExt();

        STDMETHODIMP QueryInterface(REFIID, LPVOID FAR *);
        STDMETHODIMP_(ULONG) AddRef();
        STDMETHODIMP_(ULONG) Release();
        STDMETHODIMP QueryContextMenu(HMENU hMenu, UINT indexMenu, UINT idCmdFirst, UINT idCmdLast, UINT uFlags);
        STDMETHODIMP InvokeCommand(LPCMINVOKECOMMANDINFO lpcmi);
        STDMETHODIMP GetCommandString(UINT_PTR idCmd, UINT uFlags, UINT FAR *reserved, LPSTR pszName, UINT cchMax);
        STDMETHODIMP Initialize(LPCITEMIDLIST pIDFolder, LPDATAOBJECT pDataObj, HKEY hKeyID);
};

typedef CShellExt *LPCSHELLEXT;

#endif // __WSCITECM_H
